/*
 *	app.h
 *
 *	Intellivision/EMU
 *
 *	* Mon May 23 00:00:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __APP_H__
#define __APP_H__

#include <clip.h>

/****************************************************************************
 *	
 ****************************************************************************/

/* NbNEEFCgύXꍇ́ATURBOV{`ĂB
 * `ĺAturbo()֐ɂ̂܂܈n܂B
 */
#define TURBO (-1) /*{{TODO}}*/

/* ؑցE16K\gꍇ́A
 * ELDIRECT_INTERVALɍXV^C~O[~b]`ĂB
 *   XV^C~O̖ڈ́A悻̒ʂłB
 *	11ȉ	Ԃɍ킸nOAbv̊댯B
 *	12	iEׁB48MHz/1WAITȊOł͏Ԃɍ킸nOAbv̊댯B
 *	25	iEׁB48MHz/1WAIT́A̒lK؂łB
 *	33	iEᕉׁB24MHz/2WAIT́A̒lK؂łB
 *	34ȏ	ؑւxāA_łĂ܂܂B
 * EؑցE16K\gȂꍇ́ALDIRECT_INTERVAL`ȂłB
 *   ʏ4K\ƂȂ܂B
 */
#define LDIRECT_INTERVAL 33 /*{{TODO}}*/

/* ȈՃXvCghCogꍇ́AUSE_SPRITEV{`Ă */
#define USE_SPRITE /*{{TODO}}*/
#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT1
enum {
#include "sprite.h"
	SPRITE_COUNT
};
extern const SPRITE sprite_table[SPRITE_COUNT];
#undef SPRITE_
#endif /*USE_SPRITE*/

/* I[gs[ggpꍇ́A
 * EQUICK_REPEAT_PADS`ĂB
 * EQUICK_REPEAT_PADSɍI[gs[gLɂPAD_*̑gݍ킹w肵ĂB
 * EQUICK_REPEAT_DELAYɍI[gs[gJn܂ł̎Ԃw肵ĂB
 * I[gs[ggpȂꍇ́A
 * EQUICK_REPEAT_PADS`ȂłB
 * EQUICK_REPEAT_PADS/DELAY̒`̗LɊւ炸AI[gs[g͍s܂B
 */
#define QUICK_REPEAT /*{{TODO}}*/
#define QUICK_REPEAT_PADS	(PAD_LF | PAD_UP | PAD_RI | PAD_DN)
//#define QUICK_REPEAT_DELAY	SEC(0.25)
#define QUICK_REPEAT_DELAY	SEC(0.50)

/****************************************************************************
 *	
 ****************************************************************************/

#define FPS	20			/* t[[g */
#define SEC(s)	((int)(FPS * (s)))	/* b->t[ϊ */

#define TEXTURE_LIST	PAT		/* eNX`Xg */
#define TEXTURE_COUNT	1		/* eNX`̐ */

extern const unsigned char SE_001[];

#define EXEC_FNAME	"exec.bin"
#define GROM_FNAME	"grom.bin"

typedef struct _FILEITEM {
	char fname[MAXFILENAME + 1];
	int size;
} FILEITEM;

#define MAX_FILE	50
#define MAX_DISP	13

/* main.c */
void app_init();
void app_exit();
void schedule();
void app_main();

/* fram.c */
/* dvF߂lȊȎSWX^ۑĂ */
/* %r10 cp1610_read(%r12); */		/* Read */
/* void cp1610_write(%r12, %r13); */	/* Write */

/* emu.c */
int intv_run(const char* fname, int sound_on);
unsigned char ay38910_in(AY38910* ay38910, int port);
void ay38910_out(AY38910* ay38910, int port, unsigned char data);

/****************************************************************************
 *	
 ****************************************************************************/

#include "work.h"

#endif /*__APP_H__*/
